> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/infra-controller/_mcp/server.

# Create Measured Boot Trusted Machine Approval

POST https://nico-rest-api.nico.svc.cluster.local/v2/org/{org}/nico/measured-boot/trusted-machine
Content-Type: application/json

Approve a Machine, or all Machines using `*`, for automatic promotion of its next measured-boot report.

Org must have an Infrastructure Provider entity that owns the Site. User must have authorization role with `PROVIDER_ADMIN` suffix.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/measured-boot-trusted-machine/create-measured-boot-trusted-machine

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NVIDIA Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/nico/measured-boot/trusted-machine:
    post:
      operationId: create-measured-boot-trusted-machine
      summary: Create Measured Boot Trusted Machine Approval
      description: >-
        Approve a Machine, or all Machines using `*`, for automatic promotion of
        its next measured-boot report.


        Org must have an Infrastructure Provider entity that owns the Site. User
        must have authorization role with `PROVIDER_ADMIN` suffix.
      tags:
        - measuredBootTrustedMachine
      parameters:
        - name: org
          in: path
          description: Name of the Org
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Measured Boot trusted Machine approval was created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MeasuredBootTrustedMachine'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
        '404':
          description: Error response when requested object is not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
        '500':
          description: Response when the API handler encounters an unexpected error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MeasuredBootTrustedMachineCreateRequest'
servers:
  - url: https://nico-rest-api.nico.svc.cluster.local
    description: Kubernetes Cluster
components:
  schemas:
    MeasuredBootTrustedMachineCreateRequestApprovalType:
      type: string
      enum:
        - Oneshot
        - Persist
      description: Whether the approval is consumed once or persists for future reports.
      title: MeasuredBootTrustedMachineCreateRequestApprovalType
    MeasuredBootTrustedMachineCreateRequest:
      type: object
      properties:
        siteId:
          type: string
          format: uuid
          description: ID of the Site where the approval applies.
        machineId:
          type: string
          description: Machine UUID, or `*` to approve all Machines at the Site.
        approvalType:
          $ref: >-
            #/components/schemas/MeasuredBootTrustedMachineCreateRequestApprovalType
          description: >-
            Whether the approval is consumed once or persists for future
            reports.
        pcrRegisters:
          type: string
          description: >-
            Optional comma-separated PCR register selector. All registers are
            used when omitted.
        comments:
          type: string
          description: Optional operator comments about the approval.
      required:
        - siteId
        - machineId
        - approvalType
      description: >-
        Request to approve a Machine for automatic promotion of measured-boot
        reports.
      title: MeasuredBootTrustedMachineCreateRequest
    MeasuredBootTrustedMachineApprovalType:
      type: string
      enum:
        - Oneshot
        - Persist
      description: Whether the approval is consumed once or persists for future reports.
      title: MeasuredBootTrustedMachineApprovalType
    MeasuredBootTrustedMachine:
      type: object
      properties:
        approvalId:
          type: string
          format: uuid
          description: Unique approval ID.
        machineId:
          type: string
          description: Machine UUID, or `*` when the approval applies to all Machines.
        approvalType:
          $ref: '#/components/schemas/MeasuredBootTrustedMachineApprovalType'
          description: >-
            Whether the approval is consumed once or persists for future
            reports.
        pcrRegisters:
          type: string
          description: Optional comma-separated PCR register selector.
        comments:
          type: string
          description: Optional operator comments about the approval.
        created:
          type:
            - string
            - 'null'
          format: date-time
          description: >-
            Time when the approval was created, or null when Core did not return
            a timestamp.
      required:
        - approvalId
        - machineId
        - approvalType
        - pcrRegisters
        - comments
        - created
      description: A measured-boot trusted Machine approval.
      title: MeasuredBootTrustedMachine
    NiCoApiErrorSource:
      type: string
      enum:
        - nico
      description: Source of the error.
      title: NiCoApiErrorSource
    NiCoApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: NiCoApiErrorData
    NICoAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/NiCoApiErrorSource'
          description: Source of the error.
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/NiCoApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NVIDIA Infra Controller REST API
      title: NICoAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

        ```

```

## Examples



**Request**

```json
{
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "machineId": "7c9e6679-7425-40de-944b-e07fc1f90ae7",
  "approvalType": "Oneshot"
}
```

**Response**

```json
{
  "approvalId": "1e4d5f7a-8b3c-4d2e-9f1a-123456789abc",
  "machineId": "7c9e6679-7425-40de-944b-e07fc1f90ae7",
  "approvalType": "Oneshot",
  "pcrRegisters": "0,1,2,3,4,5,6,7",
  "comments": "Approved for automatic promotion of next measured-boot report.",
  "created": "2024-01-15T09:30:00Z"
}
```

**SDK Code**

```python
import requests

url = "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine"

payload = {
    "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
    "machineId": "7c9e6679-7425-40de-944b-e07fc1f90ae7",
    "approvalType": "Oneshot"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"siteId":"3fa85f64-5717-4562-b3fc-2c963f66afa6","machineId":"7c9e6679-7425-40de-944b-e07fc1f90ae7","approvalType":"Oneshot"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine"

	payload := strings.NewReader("{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"machineId\": \"7c9e6679-7425-40de-944b-e07fc1f90ae7\",\n  \"approvalType\": \"Oneshot\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"machineId\": \"7c9e6679-7425-40de-944b-e07fc1f90ae7\",\n  \"approvalType\": \"Oneshot\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"machineId\": \"7c9e6679-7425-40de-944b-e07fc1f90ae7\",\n  \"approvalType\": \"Oneshot\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine', [
  'body' => '{
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "machineId": "7c9e6679-7425-40de-944b-e07fc1f90ae7",
  "approvalType": "Oneshot"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"machineId\": \"7c9e6679-7425-40de-944b-e07fc1f90ae7\",\n  \"approvalType\": \"Oneshot\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "machineId": "7c9e6679-7425-40de-944b-e07fc1f90ae7",
  "approvalType": "Oneshot"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/measured-boot/trusted-machine")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```